package Toulbar2API;

import java.io.*;
import java.nio.file.Files;

public class FileProcessor {

    public static double readBound(String filename) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(filename));
        try {
            while(true) {
                String line = br.readLine();
                if(line.startsWith("Initial lower and upper bounds: ")){
                    int idxStart = line.indexOf("[");
                    int idxEnd = line.indexOf(",");
                    return -Double.parseDouble(line.substring(idxStart+1,idxEnd)); // NEGATIVE bound because we minimize
                }
            }
        } finally {
            br.close();
        }
    }

    public static void renameFile(String filenameOld, String filenameNew) throws IOException {
        Files.move(new File(filenameOld).toPath(), new File(filenameNew).toPath(), java.nio.file.StandardCopyOption.REPLACE_EXISTING);
    }

    public static String runCommandAndGetBound(String command) throws IOException, InterruptedException {
        Process p1 = Runtime.getRuntime().exec(command);
        p1.waitFor();
        BufferedReader in = new BufferedReader(new InputStreamReader(p1.getInputStream()));
        String line = in.readLine();
        while(line!=null) {
            System.out.println(line);
            if(line.startsWith("Initial lower and upper bounds: ")){
                int idxStart = line.indexOf("[");
                int idxEnd = line.indexOf(",");
                return Double.toString(-Double.parseDouble(line.substring(idxStart+1,idxEnd))); // NEGATIVE bound because we minimize
            }
            line = in.readLine();
        }
        return "TIMEOUT";
    }
}
