package Utils;

public class KillerStruct{

    private int[] startOfSet;
    private int[] numElementsInSet;
    private int[] elementsOfSets;
    private int freeElementId = 0;
    private int currentId;

    public KillerStruct(int maxSets) {
        startOfSet = new int[maxSets];
        numElementsInSet = new int[maxSets];
        elementsOfSets = new int[maxSets];
    }

    public void erase(){
        for (int i = 0; i < numElementsInSet.length; i++) {
            numElementsInSet[i] = 0;
        }
        freeElementId = 0;
    }

    public void initializeSetForId(int id){
        numElementsInSet[id] = 0;
        startOfSet[id] = freeElementId;
        currentId = id;
    }

    public void addToLastInitializedSet(int element){
        if(freeElementId >= elementsOfSets.length){
            increaseArraySize();
        }
        numElementsInSet[currentId]++;
        elementsOfSets[freeElementId++] = element;
    }

    private void increaseArraySize(){
        int[] newelements = new int[2*elementsOfSets.length];
        System.arraycopy(elementsOfSets, 0, newelements, 0, elementsOfSets.length);
        elementsOfSets = newelements;
    }

    public int getSizeOfSetId(int id){
        return numElementsInSet[id];
    }

    public int getNthElementOfSetId(int id, int n){// 0-based indexing
        return elementsOfSets[startOfSet[id]+n];
    }
}
