package Utils;

public class QueueUnique {

    private int[] queue;
    private boolean[] isInQueue;

    private int elemsInQueue;
    private int freeElemInQueue;
    private int topOfQueue;

    public QueueUnique(int maxElem){

        queue = new int[maxElem];
        isInQueue = new boolean[maxElem];

        elemsInQueue = 0;
        freeElemInQueue = 0;
        topOfQueue = -1;
    }

    public int getElement(){
        if(isEmpty()){
            System.out.println("ERR: Querying empty queue (Queue Unique)");
            return 0;
        }

        int result = queue[topOfQueue];
        isInQueue[result] = false;

        topOfQueue++;
        if(topOfQueue>=queue.length){
            topOfQueue = 0;
        }

        elemsInQueue--;
        return result;
    }

    public void addElement(int id){
        if(freeElemInQueue>=queue.length){
            freeElemInQueue = 0;
        }

        if(!isInQueue[id]) {
            isInQueue[id] = true;
            queue[freeElemInQueue] = id;
            freeElemInQueue++;
            elemsInQueue++;
        }
        if(topOfQueue == -1){
            topOfQueue = 0;
        }
    }

    public boolean isEmpty(){
        return elemsInQueue==0;
    }


}
