package Utils;

import Instance.IndexedInstance;

public class SequenceSh {
    private int[] elementOfSetS;
    private int[] elemsInGivenSetS;
    private int[] startOfGivenSetS;

    private double[] valuesH;
    private int[] tupleIdsH;
    private int[] elemsInGivenVecH;
    private int[] startOfGivenVecH;

    private int sequenceLength;
    private int freeElemVecH;
    private int freeElemSetS;

    public SequenceSh(int numTuples){
        // allocate all arrays
        elementOfSetS = new int[numTuples];
        elemsInGivenSetS = new int[numTuples];
        startOfGivenSetS = new int[numTuples];

        valuesH = new double[numTuples];
        tupleIdsH = new int[numTuples];
        elemsInGivenVecH = new int[numTuples];
        startOfGivenVecH = new int[numTuples];
    }

    public void eraseSequence(){
        sequenceLength = 0;
        freeElemSetS = 0;
        freeElemVecH = 0;
    }

    public void startNewElementInSequence(){
        elemsInGivenVecH[sequenceLength] = 0;
        startOfGivenVecH[sequenceLength] = freeElemVecH;

        elemsInGivenSetS[sequenceLength] = 0;
        startOfGivenSetS[sequenceLength] = freeElemSetS;
        sequenceLength++;
    }

    public void addNonZeroElementToH(int tupleIndex, double value){
        if(freeElemVecH >= valuesH.length){
            increaseSizeOfArraysH();
        }
        int indexInValues = startOfGivenVecH[sequenceLength-1]+elemsInGivenVecH[sequenceLength-1];
        valuesH[indexInValues] = value;
        tupleIdsH[indexInValues] = tupleIndex;
        elemsInGivenVecH[sequenceLength-1]++;
        freeElemVecH++;
    }

    public void addElementToS(int tupleIndex){
        int indexInArray = startOfGivenSetS[sequenceLength-1]+elemsInGivenSetS[sequenceLength-1];
        if(indexInArray!=freeElemSetS){
            System.out.println("ERR: Add element to S (SequenceSh): indexInArray != freeElemSetS");
        }
        /*if(indexInArray == 379){
            System.out.println("ERR REMOVE HERE");
        }*/
        elementOfSetS[indexInArray] = tupleIndex;
        freeElemSetS++;
        elemsInGivenSetS[sequenceLength-1]++;
    }

    private void increaseSizeOfArraysH(){
        double[] valuesHnew = new double[valuesH.length*2];
        int[] tupleIdsHnew = new int[tupleIdsH.length*2];

        System.arraycopy(valuesH, 0, valuesHnew, 0, valuesH.length);
        System.arraycopy(tupleIdsH, 0, tupleIdsHnew, 0, tupleIdsH.length);

        valuesH = valuesHnew;
        tupleIdsH = tupleIdsHnew;
    }

    public int getLengthOfSequence(){
        return sequenceLength;
    }

    public int getSizeOfSetS(int order){
        return elemsInGivenSetS[order];
    }

    public int getElementOfSetS(int orderOfSet, int orderOfElement){// both 0-based indexing
        return elementOfSetS[startOfGivenSetS[orderOfSet]+orderOfElement];
    }

    public int getNumberOfNonzeroElementsOfVecH(int order){
        return elemsInGivenVecH[order];
    }

    public int getNonZeroTupleIdOfVecH(int orderOfVec, int orderOfElement){// both 0-based indexing
        return tupleIdsH[startOfGivenVecH[orderOfVec]+orderOfElement];
    }

    public double getNonZeroValueOfVecH(int orderOfVec, int orderOfElement){// both 0-based indexing
        return valuesH[startOfGivenVecH[orderOfVec]+orderOfElement];
    }


    public double findValueOfVecHForTupleIdAndOrder(int seqElem, int tupleId) {
        double value = 0;
        for (int i = 0; i < getNumberOfNonzeroElementsOfVecH(seqElem); i++) {
            int tupleNonZero = getNonZeroTupleIdOfVecH(seqElem,i);
            if(tupleNonZero == tupleId){
                value += getNonZeroValueOfVecH(seqElem,i);
            }
        }
        return value;
    }
}
