package Utils;

public class SparseVector {

    private double[] elements;
    private boolean[] elementIsNonzero;
    private int[] listOfNonzeroElements;
    private int numberOfNonzeroElements;

    public SparseVector(int length){
        elements = new double[length];
        elementIsNonzero = new boolean[length];
        listOfNonzeroElements = new int[length];
        numberOfNonzeroElements = 0;
    }

    public void setValue(int index, double value){
        elements[index] = value;
        if(!elementIsNonzero[index]){
            // was not zero before
            listOfNonzeroElements[numberOfNonzeroElements++] = index;
            elementIsNonzero[index] = true;
        }
    }

    public void addValue(int index, double value){
        elements[index] = value+elements[index];
        if(!elementIsNonzero[index]){
            // was not zero before
            listOfNonzeroElements[numberOfNonzeroElements++] = index;
            elementIsNonzero[index] = true;
        }
    }

    public double getValue(int index){
        return elements[index];
    }

    public void erase(){
        for (int i = 0; i < numberOfNonzeroElements; i++) {
            elements[listOfNonzeroElements[i]] = 0;
            elementIsNonzero[listOfNonzeroElements[i]] = false;
        }
        numberOfNonzeroElements = 0;
    }

    public int numberOfNonzeroElements(){
        return numberOfNonzeroElements;
    }

    public int getIndexOfNthNonzeroElement(int n){
        return listOfNonzeroElements[n];
    }
}
